<?
final class Sys {
	private function __construct() {}
	public static function getIncFiles($prefix, $inc_dir) {
		$inc_dir = realpath($inc_dir);
		$cache = new Cache();
		$cache -> setAction('inc_files|'.$inc_dir);
		if (!$cache -> checkIsCached()) {
			$inc_files = array();
			$dopen = opendir($inc_dir);
			while ($inc_file = readdir($dopen)) {
				if (!preg_match("|^$prefix\.(.*)\.php|", $inc_file, $tmp_inc_file)) continue;
				$inc_files[] = $tmp_inc_file[1];
			}
			closedir($dopen);
			$cache -> addToCache(serialize($inc_files));
		}
		return unserialize($cache -> getCache());
	}

	public static function incFileExists($prefix, $inc_dir, $get_inc_file) {
		if (in_array($get_inc_file, static::getIncFiles($prefix, $inc_dir)) && file_exists(static::getIncFilePath($prefix, $inc_dir, $get_inc_file))) return true;
		return false;
	}

	public static function getIncFile($prefix, $inc_dir, $get_inc_file) {
		if (static::incFileExists($prefix, $inc_dir, $get_inc_file)) return static::getIncFilePath($prefix, $inc_dir, $get_inc_file);
		return static::getIncFilePath($prefix, $inc_dir, 'index');
	}

	public static function getIncFilePath($prefix, $inc_dir, $get_inc_file) {
		return realpath($inc_dir).'/'.$prefix.'.'.$get_inc_file.'.php';
	}

	public static function loadExceptionClass($class_name) {
		self::loadClass('Exceptions.'.$class_name);
	}

	public static function loadClass($class_name) {
		$class_full_name = $class_name;
		if (strstr($class_name, '\\')) {
			$class_full_name = str_replace('\\', '/', $class_full_name);
		}
		$class_path = CLASSES.$class_full_name.'.php';
		if (file_exists($class_path)) include_once($class_path);
	}

	public static function tableExists($table) {
		return mysql_query('DESC `' . $table . '`') ? true : false;
	}

	public static function columnExists($table, $column) {
		$show_fields = mysql_query('SHOW FULL FIELDS FROM `' . $table . '`');
		$column_exists = false;
		while ($field = mysql_fetch_array($show_fields)) {
			if ($field[0] == $column) {
				$column_exists = true;
				break;
			}
		}
		return $column_exists;
	}

	public static function getColumn($table, $column) {
		$show_fields = mysql_query('SHOW FULL FIELDS FROM `' . $table . '`');
		$column_data = null;
		while ($field = mysql_fetch_array($show_fields)) {
			if ($field[0] == $column)
				$column_data = $field;
		}
		return $column_data;
	}

	public static function getTable($table) {
		return mysql_query('DESC ' . $table);
	}

	public static function getTableStatus($table) {
		$status = array();
		$q = mysql_query('SHOW TABLE STATUS');
		while ($row = mysql_fetch_array($q)) {
			if ($row[0] == $table) {
				$status = $row;
				break;
			}
		}
		return $status;
	}

	public static function getCollations() {
		$collations = array();
		$collations[] = '';
		$show_collations = mysql_query("SHOW COLLATION");
		while ($collation = mysql_fetch_array($show_collations)) {
			$collations[] = $collation[0];
		}
		return $collations;
	}

	public static function getEngines() {
		$engines = array();
		$show_engines = mysql_query("SHOW ENGINES");
		while ($engine = mysql_fetch_array($show_engines)) {
			$engines[] = $engine[0];
		}
		return $engines;
	}

	public static function getIndexes() {
		$indexes = array('', 'PRIMARY', 'UNIQUE', 'INDEX', 'FULLTEXT');
		return $indexes;
	}

	public static function getRowCount($table) {
		$query = mysql_query('SELECT * FROM `' . $table . '`');
		if (!$query) return 0;
		return mysql_num_rows($query);
	}

	public static function rowExists($table, $pos, $order, $order_type) {
		$row = mysql_query('SELECT * FROM `' . $table . '` ORDER BY `' . $order . '` ' . $order_type . ' LIMIT ' . $pos . ', 1');
		return mysql_num_rows($row) == 0 ? false : true;
	}

	public static function getRow($table, $pos, $order, $order_type) {
		return mysql_fetch_assoc(mysql_query('SELECT * FROM `' . $table . '` ORDER BY `' . $order . '` ' . $order_type . ' LIMIT ' . $pos . ', 1'));
	}
}
?>